#
# This file is part of the DCStella project
# Rules.make
#

DCPATH  = /opt/dreamcast
DCBIN	= $(DCPATH)/bin
STELLA	= stella-1.2
DCSTELLA= dcstella

CC	= gcc
CXX	= g++
LD	= ld
AR	= ar
RANLIB	= ranlib
M4	= m4
MAKEIP	= $(DCBIN)/makeip
DCTOOL  = $(DCBIN)/dc-tool -i ../../themes/develbba.iso
SCRAMBLE	= $(DCBIN)/scramble
CDROPTS	= dev=0,6,0 speed=4

SH4CROSS	= $(DCBIN)/sh-sega-dreamcast-
SH4CC	= $(SH4CROSS)gcc
SH4CXX	= $(SH4CROSS)g++
SH4LD	= $(SH4CROSS)ld
SH4AS	= $(SH4CROSS)as
SH4AR	= $(SH4CROSS)ar
SH4RANLIB	= $(SH4CROSS)ranlib
SH4OBJCOPY	= $(SH4CROSS)objcopy
SH4OPTIMIZE= -ml -m4-single-only \
	-O2 \
	-fexpensive-optimizations \
	-funroll-loops \
	-fstrength-reduce \
	-ffast-math \
	-fno-math-errno \
	-fomit-frame-pointer \
	-fno-builtin \
	-fschedule-insns2 \
	-falign-functions \
	-falign-labels \
	-falign-loops \
	-falign-jumps \
	-fno-strict-aliasing \
	-frerun-loop-opt \
	-fgcse \
	-fcse-follow-jumps \
	-fcse-skip-blocks \
	-fdelete-null-pointer-checks \
	-frerun-cse-after-loop \
	-foptimize-sibling-calls \
	-fthread-jumps \
	-fdelayed-branch \


#	# Don't use:
#	-finline-functions \
#	-finline-limit=6000 \
#	-ftrapv \
#	-fforce-addr \

ARMCROSS	= $(DCBIN)/arm-elf-
ARMCC	= $(ARMCROSS)gcc
ARMLD	= $(ARMCROSS)ld
ARMAS   = $(ARMCROSS)as
ARMAR   = $(ARMCROSS)ar
ARMRANLIB	= $(ARMCROSS)ranlib
ARMOBJCOPY	= $(ARMCROSS)objcopy
ARMOPTIMIZE	= -O1 -fexpensive-optimizations -funroll-loops -ffast-math -fomit-frame-pointer


