/*
 * This file is part of the DCStella project
 * location: dcstella/core/mainDC.cxx
 * written by SvOlli, based on the original Stella PropsSet.cxx
 */

#include <assert.h>
#include <strstream.h>
#include "Props.hxx"
#include "PropsSet.hxx"
#include <dream.h>
extern "C" 
{
#include "discio.h"
#include "dcload-console.h"
}
#include "Console.hxx"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PropertiesSet::PropertiesSet()
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PropertiesSet::~PropertiesSet()
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::getMD5(string md5, Properties &properties)
{
  char buffer[256];
  char *propsbuffer=NULL;
  int size;
  char *c,*p,*end;
  strstream propstream;

  
  sprintf(buffer,"%s/%s.pro",myKey.c_str(),md5.substr(0,8).c_str());
  
  properties = new Properties(&Console::defaultProperties());

  size=load_file(buffer,(void**)&propsbuffer);
  
  for(c=propsbuffer;c<(propsbuffer+size);c++)
  {
    if(*c == '\n')
    {
      *c = '\0';
    }
  }
  
  p = propsbuffer;
  propstream << p << endl;
  for(c=propsbuffer+1;c<(propsbuffer+size);c++)
  {
    if ((*(c-1) == '\0') && (*c != '\0'))
    {
      p = c;
      propstream << p << endl;
    }
  }
  propstream << "\"\"" << endl;
  propstream << "" << endl;
  free(propsbuffer);

  properties.load(propstream);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::insert(const Properties& properties)
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::insertNode(TreeNode* &t, const Properties& properties)
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::deleteNode(TreeNode *node)
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::load(string filename, const Properties* defaults, bool useList)
{
  myKey = filename;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::save(ostream& out)
{
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void PropertiesSet::saveNode(ostream& out, TreeNode *node)
{
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
uInt32 PropertiesSet::size() const
{
  return mySize;
}
