/*
 * This file is part of the DCStella project
 * location: dcstella/core/discio.h
 * written by SvOlli
 */

#define CONFIG_FILE_MAX_SIZE 4096
#define MAX_ROMS 2048
#define MAX_FILENAME_LEN 256
#define MAX_KEYS 64

extern int  numkeys;
extern char *configkey[MAX_KEYS],*configvalue[MAX_KEYS];
extern char *filename[MAX_ROMS];
extern char *romname[MAX_ROMS];

extern int  gdrom_check_drive(void);
extern void gdrom_check_lid(void);
extern int  load_file(const char *filename,void **buffer);
extern void load_config(const char *filename);
extern int  load_rom(const char *filename, uint8 *image, int shouldsize);
extern char *config_value_by_key(const char *key);
extern void config_set_key_value(const char *key, const char *value);

extern void generate_roms_list(const char *dirname,const char *listname);
extern char *get_romname(int number);
extern char *get_filename(int number);
