/*
 * This file is part of the DCStella project
 * location: dcstella/core/screen.h
 * written by SvOlli
 */

#define MAX_DC_SCREEN_SIZE_X 640
#define MAX_DC_SCREEN_SIZE_Y 480
#define MAX_SELECTION_STRING_LEN 80

#define MAX_TGA_SIZE MAX_DC_SCREEN_SIZE_X*MAX_DC_SCREEN_SIZE_Y*3+255+18
#define CHARSET8x8_SIZE 768
#define CHARSET8x16_SIZE 1536
//extern uint8 charset8x8[CHARSET8x8_SIZE];
//extern uint8 charset8x16[CHARSET8x16_SIZE];
extern uint8 *charset8x8;
extern uint8 *charset8x16;

extern int  emuVidMode;    // actual DC video mode
extern int  DC_screen_size_X;     // x size of actual DC mode
extern int  DC_screen_size_Y;     // y size of actual DC mode

extern void charset8x8to8x16();
extern void draw_char_s16(int charn,int x,int y,uint16 fg,uint16 bg);
extern void draw_char_d16(int charn,int x,int y,uint16 fg,uint16 bg);
extern void printxy(const char *text,int x, int y, uint16 fg, uint16 bg);
extern void printint(int value,int x, int y, uint16 fg, uint16 bg);
extern void printhex(uint32 value,int x, int y, uint16 fg, uint16 bg);

extern void error_flash(int color);
extern int  display_targa(const void *targa,int xpos,int ypos,int pixel_mode);

//extern int  load_targa(const char *filename,int xpos,int ypos,int pixel_mode);
extern uint32 select_one_from_list(char **list, int cont, uint32 buttonmask,
				   int *actualline, int *topoffset,
				   int x, int y, int width, int height,
				   uint16 txtfg, uint16 txtbg,
				   uint16 barfg, uint16 barbg);
extern uint32 get_cont_buttons(int cont);
