#!/usr/bin/perl -w
#
# This file is part of the DCStella project
# location: dcstella/util/mkromlist.pl
# quickly hacked together by SvOlli
#

$STELLA_PRO=$ARGV[0];
$ROMS_DIR=$ARGV[1];

if(!defined $STELLA_PRO)
{
  $STELLA_PRO="";
}

if(!defined $ROMS_DIR)
{
  $ROMS_DIR="";
}

if(("$STELLA_PRO" eq "") || ("$ROMS_DIR" eq ""))
{
#  printf("usage mkromlist.pl stella.pro roms_dir\n");
  printf("usage mkromlist.pl dcstella.pro_dir roms_dir\n");
  exit 1;
}

open(PRO,"cat $STELLA_PRO/*|");
$cartname="";
$md5sum="";
%namebymd5=();
while(<PRO>)
{
    s/\r//g;
    s/\;.*$//g;
    chomp;
    $spacepos=index($_," ");
    if($spacepos >= 0)
    {
	$key=substr($_,1,$spacepos-2);
	$value=substr($_,$spacepos+2,length($_)-$spacepos-3);
#	print "[$key]=>$value<\n";
	if("$key" eq "Cartridge.MD5")
	{
	    $md5sum="$value";
	}
	if("$key" eq "Cartridge.Name")
	{
	    $cartname="$value";
	}
	if(length($md5sum)*length($cartname) > 0)
	{
	    $namebymd5{$md5sum}=$cartname;
#	    print "*".$md5sum."*".$namebymd5{$md5sum}."*\n";
	    $md5sum="";
	    $cartname="";
	}
    }
}
close(PRO);
    
open(DIR,"ls -1 $ROMS_DIR|");
while(<DIR>)
{
    chomp;
    $md5sum=`md5sum $ROMS_DIR/$_|cut -c1-32`;
    chomp($md5sum);
#    print "$md5sum:$namebymd5{$md5sum}\n";
    if(defined $namebymd5{$md5sum})
    {
	print $_." ".$namebymd5{$md5sum}."\n";
    }
    else
    {
	print $_." ".$_."\n";
    }
}
close(DIR);
