/* This sample program shows off 640x480, but it also shows off "quiet
   initialization" which is where you tell libdream to shut up upon
   startup. This can be useful if you don't want to do serial_disable
   because you need the port, but you don't want garbage being printed
   when it's successful either. */

#include "dream.h"

int dc_main() {
	int x, y;

	/* Do initial setup */	
	dc_setup_quiet(DM_640x480, PM_RGB565);
	
	for (y=0; y<480; y++)
		for (x=0; x<640; x++) {
			int c = (x ^ y) & 255;
			vram_s[y*640+x] = ((c >> 3) << 12)
				| ((c >> 2) << 5)
				| ((c >> 3) << 0);
		}

	return 0;
}
