#include "dream.h"

char buffer[2048];
void cdfs_test() {
	uint32 fd;
	uint32 d;
	dirent_t *de;
	int amt;

	printf("Reading directory from CD-Rom:\r\n");

	/* Read and print the root directory */
	d = iso_open("/", O_RDONLY | O_DIR);
	if (d == 0) {
		printf("Can't open root!\r\n");
		return;
	}

	while ( (de=iso_readdir(d)) ) {
		printf("%s  /  ", de->name);
		if (de->size >= 0) {
			printf("%d\r\n", de->size);
		} else {
			printf("DIR\r\n");
		}
	}

	iso_close(d);

	/* Read and print a file called README.TXT (if any) */
	fd = iso_open("/README.TXT", O_RDONLY);
	if (fd == 0) {
		printf("Can't open file /README.TXT for reading.\r\n");
		return;
	}
	while ( (amt = iso_read(fd, buffer, 2048)) ) {
		int i;
		for (i=0; i<amt; i++) printf("%c", buffer[i]);
	}
	iso_close(fd);
}

int dc_main() {
	/* Do initial setup */	
	dc_setup(DM_640x480, PM_RGB565);

	cdfs_test();

	return 0;
}
