/* GhettoPlay: an S3M browser and playback util
   (c)2000 Dan Potter
*/

#include "gp.h"

/* A little texture allocation function: right now I'm still not totally
   sure what we can overwrite in the TA buffers ^_^;; so we start allocating
   at a safe space. This doesn't leave much actual texture space but it's
   enough for this example. */
uint32 texture_pool = 0x700000;
uint32 texture_alloc(uint32 size) {
	uint32 rv = texture_pool;

	/* Align to 8 bytes */	
	size = (size + 7) & (~7);
	texture_pool += size;
	
	return rv;
}


/* Creates the utility texture used for the font and mouse cursor. The
   resulting texture will be 256x256. */
#include "mouse1.h"
uint32 util_texture = 0;
void setup_util_texture() {
	uint32 ts = texture_alloc(256*256*2);
	uint16 *vram = (uint16*)(0xa4000000 + ts);
	int x, y;
	
	/* First dump in the mouse cursor */
	for (y=0; y<16; y++) {
		for (x=0; x<10; x++) {
			if (mouse1_xpm[y*10+x] == '.')
				*vram = 0xffff;
			else if (mouse1_xpm[y*10+x] == '+')
				*vram = 0xf000;
			else
				*vram = 0x0000;
			vram++;
		}
		vram += 256 - 10;
	}
	
	/* Now add the rest as ASCII characters */
	vram = (uint16*)(0xa4700000);
	for (y=0; y<8; y++) {
		for (x=0; x<16; x++) {
			/* Skip the first (it's a mouse pointer) */
			if (x != 0 || y != 0) 
				bfont_draw(vram, 256, y*16+x);
			vram += 16;
		}
		vram += 23*256;
	}
	
	util_texture = ts;
}
