/* For the full source to the S3M player, please see my DCDev web site! */

#include "dream.h"
#include "s3mplay.h"	/* Player ARM code */
#include "cyboman.h"	/* Cyboman.S3M, converted from the CyboMan! demo */

/* This is sort of an unorthodox way of using the SPU ^_^;; but it's
   how the S3M player works right now. */
volatile unsigned long *snd_dbg = (unsigned long*)0xa080ffc0;
void copy_s3m(char *song, int len) {
	snd_init();
	snd_load(song, 0x10000, len);

	/* Switch channels to mono if uncommented */
	/* snd_dbg[1] = 1; */
	
	printf("Load OK, starting ARM\r\n");
	snd_load_arm(s3mplay, sizeof(s3mplay));

	while (*snd_dbg != 3)
		;

	while (*snd_dbg == 3)
		;
}

void wait_start() {
	uint8 mcont;
	cont_cond_t cond;

	mcont = maple_controller_addr();
	if (!mcont) {
		printf("No controllers attached\r\n");
		return;
	}

	while (1) {
		/* Check for start on the controller */
		if (cont_get_cond(mcont, &cond)) {
			printf("Error getting controller status\r\n");
			return;
		}
		
		if (!(cond.buttons & CONT_START)) {
			printf("Pressed start\r\n");
			return;
		}
		
		sleep(10);
	}
}

int dc_main() {
	/* Do initial setup */	
	dc_setup(DM_640x480, PM_RGB888);

	/* Start a song playing */
	copy_s3m(s3m, sizeof(s3m));

	/* Wait for start */
	wait_start();

	/* Quit */
	snd_stop_arm();

	return 0;
}
